// ScreenSpaces.c
// by Scott Bronson
// 29 Oct 1996


#include "ScreenSpaces.h"
#include <InterfaceDefs.h>


struct {
	int depth;
	int width;
	int height;
	ulong space;
} const static space_lut[] = {
	8, 640, 480, B_8_BIT_640x480,
	8, 800, 600, B_8_BIT_800x600,
	8, 1024, 768, B_8_BIT_1024x768,
	8, 1280, 1024, B_8_BIT_1280x1024,
	8, 1600, 1200, B_8_BIT_1600x1200 ,
	16, 640, 480, B_16_BIT_640x480,
	16, 800, 600, B_16_BIT_800x600,
	16, 1024, 768, B_16_BIT_1024x768,
	16, 1280, 1024, B_16_BIT_1280x1024,
	16, 1600, 1200, B_16_BIT_1600x1200,
	32, 640, 480, B_32_BIT_640x480,
	32, 800, 600, B_32_BIT_800x600,
	32, 1024, 768, B_32_BIT_1024x768,
	32, 1280, 1024, B_32_BIT_1280x1024,
	32, 1600, 1200, B_32_BIT_1600x1200,
   	8, 1152, 900, B_8_BIT_1152x900,
   	16, 1152, 900, B_16_BIT_1152x900,
   	32, 1152, 900, B_32_BIT_1152x900,
	// not supporting B_8_BIT_640x400
};


bool MapSpaceToRes( ulong space, int *xsiz, int *ysiz, int *depth )
{
	int i;
	
	for( i=0; i<sizeof(space_lut)/sizeof(space_lut[0]); i++ ) {
		if( space_lut[i].space == space ) {
			*xsiz = space_lut[i].width;
			*ysiz = space_lut[i].height;
			*depth = space_lut[i].depth;
			return TRUE;
		}
	}
	
	return FALSE;
}


bool MapResToSpace( int xsiz, int ysiz, int depth, ulong *space )
{
	int i;
	
	for( i=0; i<sizeof(space_lut)/sizeof(space_lut[0]); i++ ) {
		if( space_lut[i].width == xsiz && space_lut[i].height == ysiz && space_lut[i].depth == depth ) {
			*space = space_lut[i].space;
			return TRUE;
		}
	}
	
	return FALSE;
}



